#if !defined(AFX_SCANDLG_H__78EFE867_142B_4EE8_BD80_DEFD63559A3B__INCLUDED_)
#define AFX_SCANDLG_H__78EFE867_142B_4EE8_BD80_DEFD63559A3B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ScanDlg.h : header file
//
#include "M30xFun.h"



#define MAX_DATA_POINTS		2048		//2K max. data points

/////////////////////////////////////////////////////////////////////////////
// CScanDlg dialog

class CScanDlg : public CDialog
{
// Construction
public:
	void		ScheduleAction_I(USHORT bDev_index);
	void		ScheduleAction_II(USHORT bDev_index);
	void		StartOnTmChkPwr();
	void		StartOnTmChkSignOn();
	void		EndScanBtnProc();
	void		MyInit();
	CScanDlg(CWnd* pParent = NULL);   // standard constructor
	virtual		~CScanDlg();
    static		void CALLBACK OnTimerProc(HWND hwnd, UINT uMsg,UINT  idEvent,DWORD  dwTime);
	void		ScheduleAction_O(USHORT bDev_index);
	int			ulTotalLogLines;
	BYTE		bNumChanScan;
	BYTE		bChanScanAvg;
	BYTE		bDev_index;
	BYTE		bDbgLvl;
	BOOLEAN		bIsM302;
	BOOL		bIsScanning;
	CM30xFun    myCM30xFun;
	_SCAN_OBJECT_DIO apScanObject;
	unsigned long ulScanCnt;
// Dialog Data
	//{{AFX_DATA(CScanDlg)
	enum { IDD = IDD_SCAN_DLG };
	CEdit	m_rate_edit;
	CComboBox	m_rate;
	CButton		m_scan_log_check;
	CStatic		m_data_points;
	CStatic		m_led_red8;
	CStatic		m_led_red7;
	CStatic		m_led_red6;
	CStatic		m_led_red5;
	CStatic		m_led_red4;
	CStatic		m_led_red3;
	CStatic		m_led_red2;
	CStatic		m_led_red1;
	CStatic		m_led_gray8;
	CStatic		m_led_gray7;
	CStatic		m_led_gray6;
	CStatic		m_led_gray5;
	CStatic		m_led_gray4;
	CStatic		m_led_gray3;
	CStatic		m_led_gray2;
	CStatic		m_led_gray1;
	CStatic		m_scan_rate;
	CStatic		m_sec_p_div;
	CComboBox	m_dc_ac_sel;
	CComboBox	m_chan_sel;
	CButton		m_cal_scan;
	CComboBox	m_num_scan_chan;
	CComboBox	m_volt_div_combo;
	CStatic		m_lcd_screen;
	CComboBox	m_avg_combo;
	CButton		m_initialization;
	CButton		m_multi_chan;
	CButton		m_do_d0;
	CButton		m_do_d1;
	CButton		m_do_d2;
	CButton		m_do_d3;
	CButton		m_do_d4;
	CButton		m_do_d5;
	CButton		m_do_d6;
	CButton		m_do_d7;
	CStatic		m_read_v0;
	CStatic		m_read_v1;
	CStatic		m_read_v2;
	CStatic		m_read_v3;
	CStatic		m_read_v4;
	CStatic		m_read_v5;
	CStatic		m_read_v6;
	CStatic		m_read_v7;
	CButton		m_sel_ch0;
	CButton		m_sel_ch1;
	CButton		m_sel_ch2;
	CButton		m_sel_ch3;
	CButton		m_sel_ch4;
	CButton		m_sel_ch5;
	CButton		m_sel_ch6;
	CButton		m_sel_ch7;
	CButton		m_dac_out_btn0;
	CButton		m_dac_out_btn1;
	CButton		m_dac_out_btn2;
	CEdit		m_dac_edit0;
	CEdit		m_dac_edit1;
	CEdit		m_dac_edit2;
	CButton		m_end_scan;
	CButton		m_sys_cal;
	CEdit		m_dbg_level;
	CButton		m_start_scan;
	CListBox	m_evt_log_wnd;
	CButton		m_poll_mode;
	CButton		m_scan_mode;
	//}}AFX_DATA
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CScanDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void PostNcDestroy();
	//}}AFX_VIRTUAL
// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CScanDlg)
	virtual void OnOK();
	afx_msg void OnClose();
	afx_msg void OnStartScan();
	afx_msg void OnInitialization();
	afx_msg void OnPollMode();
	afx_msg void OnScanMode();
	afx_msg void OnCh0();
	afx_msg void OnCh1();
	afx_msg void OnCh2();
	afx_msg void OnCh3();
	afx_msg void OnCh4();
	afx_msg void OnCh5();
	afx_msg void OnCh6();
	afx_msg void OnCh7();
	afx_msg void OnEndScan();
	afx_msg void OnDoD7();
	afx_msg void OnDoD6();
	afx_msg void OnDoD5();
	afx_msg void OnDoD4();
	afx_msg void OnDoD3();
	afx_msg void OnDoD2();
	afx_msg void OnDoD1();
	afx_msg void OnDoD0();
	afx_msg void OnMultiChan();
	afx_msg void OnSelchangeAvgCombo();
	afx_msg void OnSysCal();
	afx_msg void OnSelChangVoltDivComb();
	afx_msg void OnSelChangDcAcComb();
	afx_msg void OnPaint();
	afx_msg void OnCalScan();
	afx_msg void OnSelchangeNumChan();
	afx_msg void OnDac0Output();
	afx_msg void OnDac1Output();
	afx_msg void OnDac2Output();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	afx_msg void OnSelchangeChanSel();
	afx_msg void OnExit();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	BYTE		bSignOnOK;
	BYTE		bReTry;
	BYTE		bCurSelChan;
	void		CalNumOfChan(void);
	void		WriteDataLogFile(BYTE bWhatChan,UINT ulDataIndex,BYTE bTotalChans);
	void		CalRunningAvg(UINT ulPoints, BYTE bAvg, BYTE bChanSel);
	void		ClsScreen();
	void		PlotWnd(double fVoltage);
	void		OnDacOutputComm(BYTE bDacIndex);
	void		UpdateDigiOut(void);
	void		PrepScanObj(void);
	void		UpdateDigiIn(BYTE bDigiIn);
	void		OnChComm(BYTE bCHClicked);
	void		InitAllFonts(void);
	void		UpdateWndState(BOOLEAN bInitOK);
	void		GetConversion(void);
	void		ChanSelMask(void);
	void		AddEvtLog(CString* m_pEvtLog);
	BOOLEAN		DoReInitInstance(void);
	BOOLEAN		CheckScanFlg();
	BYTE		WhatChanSel(void);

	BYTE		bBuffWrappedDsp;

	BOOL		bInitializedOK;
	BOOL		bIsAC;
	BOOL		bNeedReadMore;

	UINT		ulOnTimeInt;//on time interval to interrupt
	UINT		nPlot_X;
	UINT		nPrev_Y[640];//recorded previous Y coodinate(for erasing)
	UINT		ulCenter;// Center coordinate ulCenter = LCD_RECT.bottom /2 
	UINT		ulNumPointsToTransfer;
	UINT		usVoltAvgArrayIndex[8];
	UINT		ulDotsPerScaleX;
	UINT		ulDotsPerScaleY;

	CString		TmpStr;
	
	double		volts_tmp[8];
	double		fSecPerDiv;
	double		fOffSet;//Offset for plot window fOffSet = 0; when slider is in the middle
	double		fDotsPerVolt;//Dots/Volts, it depends on sensitivity
	double		fScanRate;
	double		fVoltBuff[8][MAX_DATA_POINTS];
	double		fVoltAvgTmp[8][255];
	double		fVoltAvgTotal[8];

	CFont*		m_pFont1;
	CFont*		m_pFont2;
	LOGFONT		m_Font1;
	LOGFONT		m_Font2;
	COLORREF	m_bkColor0;
	COLORREF	m_bkSaved;
	CButton*	m_pChanSel[8];
	CButton*	m_pDigiOut[8];
	CWnd*		m_pChanReading[8];
	CPen*		m_pRedPen;
	CPen*		m_pYlwPen;
	CPen*		m_pWhitePen;
	FILE *		pLogFile;
	CDC*		p_LCD_CDC;
	RECT		LCD_RECT;
	CBrush		bkBrush;
	RETURN_CODE wErr_ret;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SCANDLG_H__78EFE867_142B_4EE8_BD80_DEFD63559A3B__INCLUDED_)

